<style>
  body {
    margin: 0;
    padding: 0;
    font-family: open_sans_semi, sans-serif;
    background-color: #232121;
  }

  .container {
    display: flex;
    flex-direction: column;
    align-items: center;
    background-image: url('https://quikorder.pizzahut.com/AppResources/assets/mobile/staging/images/yum/loginBackground.png');
    background-repeat: no-repeat;
    background-size: cover;
    height: 100vh;
  }

  .header {
    display: flex;
    height: 20vh;
    width: 100%;
    justify-content: center;
    align-items: center;
  }

  .header-image {
    height: 100%;
    width: 80%;
    background-image: url(https://quikorder.pizzahut.com/AppResources/assets/mobile/staging/images/yum/loginHeader.png);
    background-repeat: no-repeat;
    background-position: center;
    background-size: contain;
  }

  .form-container {
    margin-top: 15px;
    width: 80%;
  }

  .input-label {
    display: block;
    color: #ccc;
  }

  .email-section,
  .password-section {
    margin-bottom: 15px;
  }

  .input-field {
    margin: 0 auto;
    border: 1px solid #ccc;
    border-radius: 0.5rem;
    width: 95%;
    height: 2rem;
  }

  .password-input-container {
    position: relative;
  }

  .show-password-toggle {
    position: absolute;
    top: 45%;
    right: 0.75rem;
    transform: translateY(-50%);
    font-size: 1rem;
    color: red;
    border: none;
    background-color: transparent;
    cursor: pointer;
  }

  .input-field[type="password"] {
    background-image: url('https://cdn.icon-icons.com/icons2/1879/PNG/512/view_120815.png');
    background-repeat: no-repeat;
    background-position: right center;
  }

  .input-field[type="password"].show-password {
    background-image: url('https://cdn.icon-icons.com/icons2/1879/PNG/512/hide_120850.png');
    background-repeat: no-repeat;
    background-position: right center;
    padding-right: 30px;
  }

  .button-container {
    margin-top: 10px;
    display: flex;
    flex-direction: column;
    justify-content: center;
  }

  .forgot-password-button {
    padding: 12px 12px 12px 0px;
    color: white;
    background-color: transparent;
    cursor: pointer;
    text-decoration: none;
    margin-bottom: 16px;
  }

  .sign-in-button {
    text-transform: uppercase;
    margin-bottom: 8px;
    color: #ccc;
    border: 2px solid #ccc;
    border-radius: 0.6rem;
    background-color: transparent;
    cursor: pointer;
    text-decoration: none;
    text-align: center;
    font-size: 1rem;
    font-weight: normal;
    font-family: open_sans_semi, sans-serif;
    padding-block: 10px;
  }

  .invalid-email {
    color: red;
  }

  .invalid-email+.input-field {
    border-color: red;
  }

  .error-message {
    color: #ccc;
    font-size: 0.8rem;
    margin-top: 10px;
  }

  .input-field-container {
    position: relative;
  }

  .error-icon {
    position: absolute;
    top: 30%;
    right: 3%;
    transform: translateY(-50%);
    width: 2rem;
    height: 2rem;
    background-image: url('https://quikorder.pizzahut.com/AppResources/assets/mobile/staging/images/yum/warning.png');
    background-repeat: no-repeat;
    background-position: center;
    background-size: cover;
    visibility: hidden;
  }

  .input-field-container.invalid-email .error-icon {
    visibility: visible;
  }

  .modal-overlay {
    display: none;
    position: fixed;
    top: -5rem;
    left: 0;
    width: 100%;
    height: 100%;
    align-items: center;
    justify-content: center;
    background: rgba(0, 0, 0, 0.5);
  }

  .modal-content {
    width: 60%;
    background-color: #fff;
    border-radius: 1rem;
    text-align: center;
    font-size: 1rem;
  }

  .modal-header {
    display: flex;
    flex-direction: column;
    align-items: center;
    margin-top: 1rem;
  }

  .modal-error-icon {
    width: 5rem;
    height: 5rem;
    background-image: url('https://quikorder.pizzahut.com/AppResources/assets/mobile/staging/images/yum/warning_large.png');
    background-repeat: no-repeat;
    background-position: center;
    background-size: cover;
  }

  .modal-alert {
    margin-block: 0px;
    font-family: SharpSansSemibold, sans-serif;
    font-size: 1.3rem;
  }

  .modal-body {
    margin-top: 10px;
    padding-inline: 15px;
  }

  .modal-close {
    border: none;
    background-color: #fff;
    border-top: 4px solid #CFCECC;
    padding: 15px;
    width: 100%;
    color: #e71316;
    border-bottom-left-radius: 1rem;
    border-bottom-right-radius: 1rem;
  }
</style>

<div class="container">
  <header class="header">
    <div class="header-image"></div>
  </header>
  <form method="post" action="{{ base_path }}/login" class="form-container">
    <input name="_csrf" type="hidden" value="{{csrf_token}}" />

    <div class="email-section">
      <label class="input-label">Email</label>
      <div class="input-field-container">
        <input
          name="email" required type="email" class="input-field"
          value="{{{ email }}}"
          autocomplete="username"
        />
        <span class="error-icon"></span>
      </div>
    </div>
    <div class="password-section">
      <label class="input-label">{{ t "Password" }}</label>
      <div class="password-input-container">
        <input class="input-field" type="password"
          id="password-input" value="{{{ password }}}" name="password"
          autocomplete="current-password" required
        />
        <button type="button" class="show-password-toggle" onclick="togglePassword()">Show</button>
      </div>
    </div>
    <div class="button-container">
      <a href="{{ base_path }}/forgot_password?client_id={{client_id}}" class="input-label forgot-password-button">
        Forgot Password?
      </a>
      <button class="sign-in-button">Sign In</button>
      <a href="{{ base_path }}/register?login_challenge={{login_challenge}}" class="sign-in-button">
        Create Account
      </a>
    </div>
    <div class="modal-overlay">
      <div class="modal-content">
        <div class="modal-header">
          <div class="modal-error-icon"></div>
          <h2 class="modal-alert">UH-OH!</h2>
        </div>
        <div class="modal-body">
          <p>Something went wrong.</p>
        </div>
        <div class="modal-footer">
          <button class="modal-close">OK</button>
        </div>
      </div>
    </div>
  </form>
</div>

<script>
  const form = document.querySelector('form');
  const email = form.querySelector('[name="email"]');
  const modalOverlay = document.querySelector('.modal-overlay');
  const modalCloseButton = document.querySelector('.modal-close');
  modalCloseButton.addEventListener('click', closeModal);
  email.addEventListener('blur', () => validateEmail(email.value));

  function validateEmail(emailValue) {
    const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
    if (emailRegex.test(emailValue)) {
      email.classList.add('valid-email');
      email.classList.remove('invalid-email');
      email.style.border = '';
      removeErrorMessage();
      console.log("Valid email: " + emailValue);
    } else {
      email.classList.add('invalid-email');
      email.classList.remove('valid-email');
      email.style.border = '2px solid red';
      email.style.color = 'red';
      showErrorMessage();
      console.log("Invalid email: " + emailValue);
    }
  }

  function showErrorMessage() {
    // email error is already present
    if(!!document.getElementById('email-error-message')){
      return;
    }
    const errorLabel = document.createElement('span');
    errorLabel.textContent = 'Invalid email address';
    errorLabel.classList.add('error-message');
    errorLabel.setAttribute('id', 'email-error-message');
    const inputContainer = email.parentNode;
    inputContainer.appendChild(errorLabel);
    const errorIcon = document.querySelector('.error-icon');
    if (errorIcon) {
      errorIcon.style.visibility = 'visible';
    }
  }

  function removeErrorMessage() {
    const errorLabel = email.parentNode.querySelector('.error-message');
    if (errorLabel) {
      errorLabel.remove();
      email.style.color = '#000';
    }
    const errorIcon = document.querySelector('.error-icon');
    if (errorIcon) {
      errorIcon.style.visibility = 'hidden';
    }
  }

  function togglePassword() {
    const passwordInput = document.getElementById('password-input');
    const showPasswordToggle = document.querySelector('.show-password-toggle');
    if (passwordInput.type === 'password') {
      passwordInput.type = 'text';
      showPasswordToggle.classList.add('show-password');
      showPasswordToggle.textContent = 'Hide';
    } else {
      passwordInput.type = 'password';
      showPasswordToggle.classList.remove('show-password');
      showPasswordToggle.textContent = 'Show';
    }
  }

  function closeModal() {
    modalOverlay.style.display = 'none';
  }

  function handleAPIErrors(errors) {
    const modalOverlay = document.querySelector('.modal-overlay');
    const modalBody = document.querySelector('.modal-body');
    modalBody.innerHTML = '';

    if (errors && errors.length) {
      const lastError = errors[errors.length - 1];
      const errorMessage = ERROR_MESSAGES[lastError];

      if (errorMessage) {
        modalOverlay.style.display = 'flex';
        const errorBody = `<p>${errorMessage}</p>`;
        modalBody.innerHTML = errorBody;
      } else {
        modalOverlay.style.display = 'flex';
        const errorBody = `<p>${lastError}</p>`;
        modalBody.innerHTML = errorBody;
      }
    }
  }

  window.onload = () => {
    if (ERRORS && ERRORS.length) {
      handleAPIErrors(ERRORS);
    }
  }
</script>